ConRO.Paladin = {};
ConRO.Paladin.CheckTalents = function()
end
local ConRO_Paladin, ids = ...;

function ConRO:EnableRotationModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Paladin.CheckTalents;
	if mode == 1 then
		self.Description = "Paladin [Holy - Healer]";
		self.NextSpell = ConRO.Paladin.Holy;
		self.ToggleHealer();
	end;
	if mode == 2 then
		self.Description = "Paladin [Protection - Tank]";
		self.NextSpell = ConRO.Paladin.Protection;
		self.ToggleDamage();
		self.BlockBurst();
		self.BlockAoE();
	end;
	if mode == 3 then
		self.Description = "Paladin [Retribution - Melee]";
		self.NextSpell = ConRO.Paladin.Retribution;
		self.ToggleDamage();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Paladin.CheckTalents;
	if mode == 1 then
		self.NextDef = ConRO.Paladin.HolyDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.Paladin.ProtectionDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.Paladin.RetributionDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

function ConRO.Paladin.Holy(_, timeShift, currentSpell, gcd, tChosen)
--Abilities	
	local avenge 											= ConRO:AbilityReady(ids.Holy_Ability.AvengingWrath, timeShift);
	local auram 											= ConRO:AbilityReady(ids.Holy_Ability.AuraMastery, timeShift);
	local judg	 											= ConRO:AbilityReady(ids.Holy_Ability.Judgment, timeShift);
	local shock 											= ConRO:AbilityReady(ids.Holy_Ability.HolyShock, timeShift);
	local cstrike				 							= ConRO:AbilityReady(ids.Holy_Ability.CrusaderStrike, timeShift);
		local csCharges											= ConRO:SpellCharges(ids.Holy_Ability.CrusaderStrike);

--Conditions	
	local isEnemy 											= ConRO:TarHostile()

--Indicators	
	ConRO:AbilityBurst(ids.Holy_Ability.AvengingWrath, avenge);
	ConRO:AbilityBurst(ids.Holy_Ability.AuraMastery, auram);

--Rotations
	if isEnemy then
		if judg then
			return ids.Holy_Ability.Judgment;
		end
		
		if shock then
			return ids.Holy_Ability.HolyShock;
		end
		
		if cstrike and csCharges >= 1 then
			return ids.Holy_Ability.CrusaderStrike;
		end
	end	
	return nil;
end

function ConRO.Paladin.HolyDef(_, timeShift, currentSpell, gcd, tChosen)
--Abilities		
	local loh 												= ConRO:AbilityReady(ids.Holy_Ability.LayonHands, timeShift);
	local dish 												= ConRO:AbilityReady(ids.Holy_Ability.DivineShield, timeShift);
	local bop 												= ConRO:AbilityReady(ids.Holy_Ability.BlessingofProtection, timeShift);
	
	local forb 												= ConRO:Aura(ids.Holy_Debuff.Forbearance, timeShift, 'HARMFUL');

--Conditions
	local playerPh 											= ConRO:PercentHealth('player');

--Rotations
	if loh and not forb and playerPh <= 10 then
		return ids.Holy_Ability.LayonHands;
	end
	
	if dish and not forb then
		return ids.Holy_Ability.DivineShield;
	elseif bop and not forb then 
		return ids.Holy_Ability.BlessingofProtection;
	end
	
	return nil;
end

function ConRO.Paladin.Protection(_, timeShift, currentSpell, gcd, tChosen)
--Abilities
	local hofreck 											= ConRO:AbilityReady(ids.Prot_Ability.HandofReckoning, timeShift);
	local rebuke 											= ConRO:AbilityReady(ids.Prot_Ability.Rebuke, timeShift);
	local judge 											= ConRO:AbilityReady(ids.Prot_Ability.Judgment, timeShift);
	local ashield											= ConRO:AbilityReady(ids.Prot_Ability.AvengersShield, timeShift);
	local avenge 											= ConRO:AbilityReady(ids.Prot_Ability.AvengingWrath, timeShift);
	local sotr								 				= ConRO:AbilityReady(ids.Prot_Ability.ShieldoftheRighteous, timeShift);
		local sotrCharges, sotrMaxCharges						= ConRO:SpellCharges(ids.Prot_Ability.ShieldoftheRighteous);
	local con 												= ConRO:AbilityReady(ids.Prot_Ability.Consecration, timeShift);
	local hotr 												= ConRO:AbilityReady(ids.Prot_Ability.HammeroftheRighteous, timeShift);
	
	local bh 												= ConRO:AbilityReady(ids.Prot_Talent.BlessedHammer, timeShift);
		local bhCharges, bhMaxCharges							= ConRO:SpellCharges(ids.Prot_Talent.BlessedHammer);			
	local sera 												= ConRO:AbilityReady(ids.Prot_Talent.Seraphim, timeShift);
	
	local conBuff 											= ConRO:Form(ids.Prot_Form.Consecration);
	
	local bhDebuff 											= ConRO:TargetAura(ids.Prot_Debuff.BlessedHammer, timeShift);

--Conditions
	local incombat 											= UnitAffectingCombat('player');
	local inRange 											= ConRO:IsSpellInRange(GetSpellInfo(ids.Prot_Ability.Rebuke), 'target');
	
--Indicators
	ConRO:AbilityInterrupt(ids.Prot_Ability.AvengersShield, ashield and ConRO:Interrupt());
	ConRO:AbilityInterrupt(ids.Prot_Ability.Rebuke, rebuke and not ashield and ConRO:Interrupt());
	ConRO:AbilityTaunt(ids.Prot_Ability.HandofReckoning, hofreck and (not ConRO:InRaid() or (ConRO:InRaid() and ConRO:TarYou())));
	
	ConRO:AbilityBurst(ids.Prot_Ability.AvengingWrath, avenge);
	ConRO:AbilityBurst(ids.Prot_Talent.Seraphim, sera and sotrCharges >= 2);

--Rotations	
	if not inRange and judge then
		return ids.Prot_Ability.Judgment;
	end
	
	if con and not conBuff then
		return ids.Prot_Ability.Consecration;
	end

	if sotr and sotrCharges == sotrMaxCharges then
		return ids.Prot_Ability.ShieldoftheRighteous;
	end
	
	if judge then
		return ids.Prot_Ability.Judgment;
	end
	
	if ashield then
		return ids.Prot_Ability.AvengersShield;
	end
	
	if bh and (bhCharges == bhMaxCharges or not bhDebuff) then
		return ids.Prot_Talent.BlessedHammer;
	elseif not tChosen[ids.Prot_Talent.BlessedHammer] and hotr then
		return ids.Prot_Ability.HammeroftheRighteous;
	end
	return nil;
end

function ConRO.Paladin.ProtectionDef(_, timeShift, currentSpell, gcd, tChosen)
--Abilities	
	local ad, adCD			 								= ConRO:AbilityReady(ids.Prot_Ability.ArdentDefender, timeShift);
	local goak 												= ConRO:AbilityReady(ids.Prot_Ability.GuardianofAncientKings, timeShift);
	local sotr, sotrCD										= ConRO:AbilityReady(ids.Prot_Ability.ShieldoftheRighteous, timeShift);
		local sotrCharges, sotrMaxCharges						= ConRO:SpellCharges(ids.Prot_Ability.ShieldoftheRighteous);
	local dish 												= ConRO:AbilityReady(ids.Prot_Ability.DivineShield, timeShift);
	local bop 												= ConRO:AbilityReady(ids.Prot_Ability.BlessingofProtection, timeShift);
	local lotp 												= ConRO:AbilityReady(ids.Prot_Ability.LightoftheProtector, timeShift);
	local loh 												= ConRO:AbilityReady(ids.Prot_Ability.LayonHands, timeShift);
	
	local hotp 												= ConRO:AbilityReady(ids.Prot_Talent.HandoftheProtector, timeShift);
	local bol 												= ConRO:AbilityReady(ids.Prot_Talent.BastionofLight, timeShift);
		
	local forb 												= ConRO:Aura(ids.Prot_Debuff.Forbearance, timeShift, 'HARMFUL');

--Conditions	
	local inRange 											= ConRO:IsSpellInRange(GetSpellInfo(ids.Prot_Ability.ShieldoftheRighteous), 'target');
	local playerPh 											= ConRO:PercentHealth('player');

--Rotations	
	if loh and not forb and playerPh <= 10 then
		return ids.Prot_Ability.LayonHands;
	end
		
	if hotp and playerPh <= 50 then
		return ids.Prot_Talent.HandoftheProtector;
	elseif not tChosen[ids.Prot_Talent.HandoftheProtector] and lotp and playerPh <= 50 then
		return ids.Prot_Ability.LightoftheProtector;
	end
	
	if bol and sotrCharges == 0 and sotrCD > 5 then
		return ids.Prot_Talent.BastionofLight;
	end
	
	if sotr and sotrCharges >= 2 then
		return ids.Prot_Ability.ShieldoftheRighteous;
	end

	if ad or adCD <= 1 then
		return ids.Prot_Ability.ArdentDefender;
	end
			
	if dish and not forb then
		return ids.Prot_Ability.DivineShield;
	end
	
	if bop and not forb and not tChosen[ids.Prot_Talent.BlessingofSpellwarding] then 
		return ids.Prot_Ability.BlessingofProtection;
	end
	
	if goak then
		return ids.Prot_Ability.GuardianofAncientKings;
	end

	return nil;
end

function ConRO.Paladin.Retribution(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local hpower 											= UnitPower ('player', Enum.PowerType.HolyPower);

--Abilities	
	local cstrike											= ConRO:AbilityReady(ids.Ret_Ability.CrusaderStrike, timeShift);
		local csCharges											= ConRO:SpellCharges(ids.Ret_Ability.CrusaderStrike);
	local temp 												= ConRO:AbilityReady(ids.Ret_Ability.TemplarsVerdict, timeShift);
	local dstorm 											= ConRO:AbilityReady(ids.Ret_Ability.DivineStorm, timeShift);
	local blade 											= ConRO:AbilityReady(ids.Ret_Ability.BladeofJustice, timeShift);
	local judge 											= ConRO:AbilityReady(ids.Ret_Ability.Judgment, timeShift);
	local awrath, awCD										= ConRO:AbilityReady(ids.Ret_Ability.AvengingWrath, timeShift);
		local awBuff											= ConRO:Aura(ids.Ret_Buff.AvengingWrath, timeShift);
	local rebuke 											= ConRO:AbilityReady(ids.Ret_Ability.Rebuke, timeShift);

	local washes											= ConRO:AbilityReady(ids.Ret_Talent.WakeofAshes, timeShift);
	local cru, cruCD										= ConRO:AbilityReady(ids.Ret_Talent.Crusade, timeShift);
		local cBuff												= ConRO:Aura(ids.Ret_Buff.Crusade, timeShift);
	local jveng												= ConRO:AbilityReady(ids.Ret_Talent.JusticarsVengeance, timeShift);
	local esent												= ConRO:AbilityReady(ids.Ret_Talent.ExecutionSentence, timeShift);
	local hofw 												= ConRO:AbilityReady(ids.Ret_Talent.HammerofWrath, timeShift);
	local con												= ConRO:AbilityReady(ids.Ret_Talent.Consecration, timeShift);
	local inq												= ConRO:AbilityReady(ids.Ret_Talent.Inquisition, timeShift);
		local inqBuff											= ConRO:Aura(ids.Ret_Buff.Inquisition, timeShift + 5);
		
	local dpBuff 											= ConRO:Aura(ids.Ret_Buff.DivinePurpose, timeShift);
	local fofjBuff											= ConRO:Aura(ids.Ret_Buff.TheFiresofJustice, timeShift);

--Conditions
	local targetPh 											= ConRO:PercentHealth('target');
	local canExe 											= targetPh < 20;
	
	if fofjBuff then
		hpower = hpower + 1;
	end
	
	if dpBuff then
		hpower = 5;
	end	
	
--Indicators		
	ConRO:AbilityInterrupt(ids.Ret_Ability.Rebuke, rebuke and ConRO:Interrupt());
	ConRO:AbilityBurst(ids.Ret_Talent.Crusade, cru and hpower >= 3 and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ret_Ability.AvengingWrath, awrath and (not tChosen[ids.Ret_Talent.Inquisition] or (inqBuff and tChosen[ids.Ret_Talent.Inquisition])) and ConRO_BurstButton:IsVisible());

--Rotations	
	if washes and hpower == 0 and ((tChosen[ids.Ret_Talent.Crusade] and (cBuff or cruCD >= 45)) or (not tChosen[ids.Ret_Talent.Crusade] and (awBuff or awCD >= 45))) then
		return ids.Ret_Talent.WakeofAshes;
	end
	
	if blade and hpower <= 3 then
		return ids.Ret_Ability.BladeofJustice;
	end
	
	if judge and hpower <= 4 then
		return ids.Ret_Ability.Judgment;
	end
		
	if hofw and hpower <= 4 and (canExe or cBuff or awBuff) then
		return ids.Ret_Talent.HammerofWrath;
	end

	if inq and hpower >= 3 and not inqBuff then
		return ids.Ret_Talent.Inquisition;
	end
	
	if cru and hpower >= 3 and ConRO_FullButton:IsVisible() then
		return ids.Ret_Talent.Crusade;
	end
	
	if awrath and (inqBuff or not tChosen[ids.Ret_Talent.Inquisition]) and not tChosen[ids.Ret_Talent.Crusade] and ConRO_FullButton:IsVisible() then
		return ids.Ret_Ability.AvengingWrath;
	end
	
	if con and hpower <= 4 then
		return ids.Ret_Talent.Consecration;
	end
	
	if cstrike and hpower <= 4 and csCharges >= 2 and not (tChosen[ids.Ret_Talent.HammerofWrath] and (cBuff or awBuff or canExe)) then
		return ids.Ret_Ability.CrusaderStrike;
	end
	
	if esent and hpower >= 3 then
		return ids.Ret_Talent.ExecutionSentence;
	end
	
	if ConRO_AoEButton:IsVisible() then
		if dstorm and hpower >= 3 then
			return ids.Ret_Ability.DivineStorm;
		end
	else
		if temp and hpower >= 3 then
			return ids.Ret_Ability.TemplarsVerdict;
		end
	end

	if cstrike and hpower <= 4 and csCharges >= 1 then
		return ids.Ret_Ability.CrusaderStrike;
	end	
end

function ConRO.Paladin.RetributionDef(_, timeShift, currentSpell, gcd, tChosen)
--Abilities
	local sov 												= ConRO:AbilityReady(ids.Ret_Ability.ShieldofVengeance, timeShift);
	local dish 												= ConRO:AbilityReady(ids.Ret_Ability.DivineShield, timeShift);
	local bop 												= ConRO:AbilityReady(ids.Ret_Ability.BlessingofProtection, timeShift);
	local loh 												= ConRO:AbilityReady(ids.Ret_Ability.LayonHands, timeShift);
		local forb 												= ConRO:Aura(ids.Ret_Debuff.Forbearance, timeShift, 'HARMFUL')	
		
	local efoe 												= ConRO:AbilityReady(ids.Ret_Talent.EyeforanEye, timeShift);

--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');

--Rotations	
	if loh and not forb and playerPh <= 10 then
		return ids.Ret_Ability.LayonHands;
	end
	
	if sov then
		return ids.Ret_Ability.ShieldofVengeance;
	end
	
	if efoe then
		return ids.Ret_Talent.EyeforanEye;
	end	
	
	if dish and not forb then
		return ids.Ret_Ability.DivineShield;
	end
	
	if bop and not forb then 
		return ids.Ret_Ability.BlessingofProtection;
	end
	
	return nil;
end
